<html>
<head>
<title>KiCad repository installation script</title>
<link rel=stylesheet href="kicad.css" type="text/css">
</head>
<body>
<h2>KiCad repository installation script</h2>
<ul>
<?php
error_reporting (E_ALL | E_STRICT);
include "configuration.php";
$errors = 0;

echo "<li>users";
if ($db->exec("create table ".TABLE_PREFIX."users (
               user_id INTEGER ".AUTOINCREMENT." PRIMARY KEY,
               username VARCHAR(64),
               userpwd VARCHAR(32),
               email VARCHAR(128),
               group_id INTEGER,
               timestamp INTEGER)") === FALSE)
{
    $errors += 1;
    echo " failure\n";
} else {
    echo " ok\n";
}

echo "<li>groups";
if ($db->exec("create table ".TABLE_PREFIX."groups (
               group_id INTEGER ".AUTOINCREMENT." PRIMARY KEY,
               groupname VARCHAR(64),
               grouppwd VARCHAR(32),
               timestamp INTEGER)") === FALSE)
{
    $errors += 1;
    echo " failure\n";
} else {
    echo " ok\n";
}

echo "<li>symbols";
if ($db->exec("create table ".TABLE_PREFIX."symbols (
               symbol_id INTEGER ".AUTOINCREMENT." PRIMARY KEY,
               user_id INTEGER,
               partname VARCHAR(64),
               description VARCHAR(128),
               keywords VARCHAR(128),
               aliases VARCHAR(256),
               fplist VARCHAR(256),
               data TEXT,
               timestamp INTEGER)") === FALSE)
{
    $errors += 1;
    echo " failure\n";
} else {
    echo " ok\n";
}

echo "<li>footprints";
if ($db->exec("create table ".TABLE_PREFIX."footprints (
               symbol_id INTEGER ".AUTOINCREMENT." PRIMARY KEY,
               user_id INTEGER,
               partname VARCHAR(64),
               description VARCHAR(128),
               keywords VARCHAR(128),
               pitch FLOAT,
               span FLOAT,
               pins INTEGER,
               data TEXT,
               timestamp INTEGER)") === FALSE)
{
    $errors += 1;
    echo " failure\n";
} else {
    echo " ok\n";
}

echo "<li>3D models";
if ($db->exec("create table ".TABLE_PREFIX."models (
               symbol_id INTEGER ".AUTOINCREMENT." PRIMARY KEY,
               user_id INTEGER,
               partname VARCHAR(64),
               data TEXT,
               timestamp INTEGER)") === FALSE)
{
    $errors += 1;
    echo " failure\n";
} else {
    echo " ok\n";
}

?>
</ul>

<?php
if ($errors > 0) {
    print "<b>Creating one or more tables failed. Consult the error messages.</b>";
} else {
    print "<b>Creating tables successfully completed.</b>";
}
?>
</body>
</html>