<html>
<head>
<title>KiCad Repository</title>
<link rel="stylesheet" type="text/css" href="simple-and-clean.css">
</head>
<body>
<h1>The KiCad Repository</h1>
<p>The KiCad repository is a database for footprints and schematic symbols
for the <a href="http://www.kicad-pcb.org/">KiCad EDA suite</a>.
To use the repository, you also need the
<a href="http://www.compuphase.com/electronics/kicadlibrarian_en.htm">KiCad Librarian</a>.
</p>
<p>
In the KiCad Librarian, you can sign up to the repository, after which an email
with a password is sent. Once the account is activated, you can use the Librarian
to copy symbols and footprints into and out of the repository.
</p>
<p>
You can host the KiCad repository on your own server (in fact, that is the intended
purpose). Download the archive with full source and installation instructions from the
<a href="http://www.compuphase.com/electronics/kicadlibrarian_en.htm">KiCad Librarian page</a>.
</p>

<?php
    $query = $db->prepare("SELECT count(symbol_id) FROM ".TABLE_PREFIX."symbols");
    if ($query->execute()) {
        $result = $query->fetch();
        $symbols = $result[0];
    }
    $query = $db->prepare("SELECT count(symbol_id) FROM ".TABLE_PREFIX."footprints");
    if ($query->execute()) {
        $result = $query->fetch();
        $footprints = $result[0];
    }
    $query = $db->prepare("SELECT count(symbol_id) FROM ".TABLE_PREFIX."models");
    if ($query->execute()) {
        $result = $query->fetch();
        $models = $result[0];
    }
    $query = $db->prepare("SELECT count(user_id) FROM ".TABLE_PREFIX."users");
    if ($query->execute()) {
        $result = $query->fetch();
        $users = $result[0];
    }
?>

<h2>Status</h2>
<p>
The repository currently holds <?php print($symbols); ?> symbols,
<?php print($footprints); ?> footprints and <?php print($models); ?> models by
<?php print($users); ?> authors.
</p>

<h2>Footprints</h2>
<br/>
<table>
  <thead>
    <tr><th>&nbsp;</th><th>name</th><th>description</th><th>pitch (mm)</th><th>span (mm)</th><th>pins</th><th>3D model</th><th>author</th><th>updated</th></tr>
  </thead>
  <tbody>
    <?php
      $usertable = TABLE_PREFIX . "users";
      $footprinttable = TABLE_PREFIX . "footprints";
      $symboltable = TABLE_PREFIX . "symbols";
      $modeltable = TABLE_PREFIX . "models";

      $query = $db->prepare("SELECT partname,description,pitch,span,pins,username,$footprinttable.timestamp FROM $footprinttable JOIN $usertable ON $footprinttable.user_id=$usertable.user_id ORDER BY partname");
      if ($query->execute()) {
        while (($row = $query->fetch())) {
          $hasmodel = false;
          $qm = $db->prepare("SELECT count(symbol_id) FROM $modeltable WHERE partname=:partname");
          if ($qm->execute(array(':partname' => $row[0] . ".wrl")) && ($rm = $qm->fetch()))
            $hasmodel = ($rm[0] > 0);
		  $imagename = "./bitmaps/footprint_" . replace_slashes($row[0]) . ".png";
          ?>
          <tr>
          <td>
            <span class="preview">
              <img src="<?php print($imagename); ?>" alt="<?php print($row[0]); ?>" width="48" height="48">
              <span>
                <img src="<?php print($imagename); ?>" alt="<?php print($row[0]); ?>">
              </span>
            </span>
          </td>
          <td><?php print($row[0]); ?></td>
          <td><?php print($row[1]); ?></td>
          <td><?php if ((float)$row[2] > 0) printf("%.3f",$row[2]); ?></td>
          <td><?php if ((float)$row[3] > 0) printf("%.2f",$row[3]); ?></td>
          <td><?php if ((int)$row[4] > 0) printf("%d",$row[4]); ?></td>
          <td><?php print($hasmodel ? "yes" : "no"); ?></td>
          <td><?php print($row[5]); ?></td>
          <td><?php print(date("Y-m-d H:i:s", $row[6])); ?></td>
          </tr>
          <?php
        }
        $query->closeCursor();
      }
    ?>
  </tbody>
</table>

<h2>Symbols</h2>
<br/>
<table>
  <thead>
    <tr><th>&nbsp;</th><th>name</th><th>description</th><th>aliases</th><th>footprints</th><th>author</th><th>updated</th></tr>
  </thead>
  <tbody>
    <?php
      $query = $db->prepare("SELECT partname,description,aliases,fplist,username,$symboltable.timestamp FROM $symboltable JOIN $usertable ON $symboltable.user_id=$usertable.user_id ORDER BY partname");
      if ($query->execute()) {
        while (($row = $query->fetch())) {
          $imagename = "./bitmaps/symbol_" . replace_slashes($row[0]) . ".png";
          ?>
          <tr>
          <td>
            <span class="preview">
              <img src="<?php print($imagename); ?>" alt="<?php print($row[0]); ?>" width="48" height="48">
              <span>
                <img src="<?php print($imagename); ?>" alt="<?php print($row[0]); ?>">
              </span>
            </span>
          </td>
          <td><?php print($row[0]); ?></td>
          <td><?php print($row[1]); ?></td>
          <td><?php print($row[2]); ?></td>
          <td><?php print($row[3]); ?></td>
          <td><?php print($row[4]); ?></td>
          <td><?php print(date("Y-m-d H:i:s", $row[5])); ?></td>
          </tr>
          <?php
        }
        $query->closeCursor();
      }
    ?>
  </tbody>
</table>

</body>
</html>
